import { Ref, InjectionKey, UnwrapRef } from 'vue-demi';
declare type Fn = () => void;
export declare type UnwrapNestedRefs<T> = T extends Ref ? T : UnwrapRef<T>;
export declare type Conditions<T> = {
    [K in keyof T]: T[K];
};
export declare type ConditionsType = {
    [key: string]: any;
};
export interface OnFetchErrorContext<T = any, E = any> {
    error: E;
    data: T | null;
}
export interface Config<O> {
    fetcher: (params: object) => Promise<any>;
    conditions: O;
    defaultParams?: object;
    immediate?: boolean;
    initialData?: any;
    beforeFetch?: (conditions: O & ConditionsType, cancel: Fn) => ConditionsType;
    afterFetch?: (data: any) => any;
    onFetchError?: (ctx: OnFetchErrorContext) => Promise<Partial<OnFetchErrorContext>> | Partial<OnFetchErrorContext>;
}
export interface QueryOptions<K> {
    sync?: InjectionKey<any> | string;
    navigation?: 'push' | 'replace';
    ignore?: Array<K>;
}
export interface UseConditionWatcherReturn<O> {
    conditions: UnwrapNestedRefs<O>;
    loading: Ref<boolean | false>;
    data: Ref<any | null>;
    error: Ref<any | null>;
    execute: () => Promise<any>;
    resetConditions: VoidFunction;
    onConditionsChange: (fn: ([newConditions, oldConditions]: [any, any]) => void) => void;
}
export {};
